.386
.model flat,c

.const
text_internal_error db "Internal error", 0
text_error_reading db "Error reading input file", 0
text_input_file_corrupted db "Input file corrupted", 0

.data
; ******************** window cyclic buffer definition **********************
buffer_length = 2080
actual_window_length = 32
search_window_length = 2048
buffer db buffer_length dup(0) ;cyclic buffer
buffer_start_ptr dd offset buffer
buffer_end_ptr dd (offset buffer) + buffer_length
buffer_actual_window_ptr dd offset buffer
;buffer_actual_window_end_ptr dd (offset buffer) + actual_window_length
buffer_search_window_ptr dd (offset buffer) + actual_window_length

; **********************
error_text dd 0
helper dd ?

; **********************
; After initialization situation looks like:
;
; |---------------------------- buffer ----------------------------------------------------|
; |-actual window(32)-|------------------- search window (2080)----------------------------|
;
; ^ buffer_start_ptr
; ^ buffer_actual_window_ptr
;                     ^ buffer_serch_window_ptr
;                                                                            buffer_end_ptr  ^ (points BEHIND buffer)

; ******************* read, write buffer definition ************************
.data?
read_buffer_length = actual_window_length
write_buffer_length = actual_window_length ;maximum size for compressing: 8 flag bits + 8 * (5 bits + 11 bits); maximum size for decompressing is actual_window_length - this is larger
read_buffer db read_buffer_length dup (?)
read_buffer_end_ptr = offset read_buffer + read_buffer_length
write_buffer db write_buffer_length dup (?) 
write_buffer_end_ptr = offset write_buffer + write_buffer_length
flags_buffer db ?
; **************************************************************************

.code
extrn mymalloc:proc
extrn myfree:proc
extrn puts:proc

; **************************************************************************


include lz77cd.asm
include lz77d.asm
include lz77c.asm


end
